#! /bin/bash

header="#\n# This file was generated automatically with the gdalsrsinfo utility,\n# using EPSG codes found in gcs.csv and pcs.csv\n#"

gcs_epsg=`cat /home/softdev/share/gdal/gcs.csv | awk -F "\"*,\"*"  '{ if (NR!=1) print($1); }'`
pcs_epsg=`cat /home/softdev/share/gdal/pcs.csv | awk -F "\"*,\"*"  '{ if (NR!=1) print($1); }'`
ogc_file=epsg_ogc.wkt
ogcs_file=epsg_ogc_simple.wkt
esri_file=epsg_esri.wkt
#pcs_file=pcs.wkt

echo -e $header > $ogc_file
echo -e "# Format is conformant to the \"OGC WKT\" specification\n#" >> $ogc_file
echo -e $header > $ogcs_file
echo -e "# Format is conformant to the \"OGC WKT\" Simple Features 1.0 specification\n#" >> $ogcs_file
echo -e $header > $esri_file
echo -e "# Format is conformant to the \"ESRI WKT\" specification\n#" >> $esri_file

#do_code_ofile <code> <ofile> <otype>
function do_code_ofile()
{
    code=$1
    ofile=$2
    otype=$3
    oline=`gdalsrsinfo -o $otype EPSG:$code`
    echo -n $code"," >> $ofile
    if [ ! -z "$oline" ]; then
        echo $oline >> $ofile
    else 
        echo "" >> $ofile
    fi
}

for code in $gcs_epsg $pcs_epsg; do

#    echo $code
    do_code_ofile $code $ogc_file wkt &
    do_code_ofile $code $ogcs_file wkt_noct &
    do_code_ofile $code $esri_file wkt_esri &

    wait

done

gzip -f $ogcs_file
gzip -f $ogc_file
gzip -f $esri_file

